<script lang="ts">
  import { AddTeamMemberStore, ParticipantCreateTeamStore } from '$houdini';
  import HeaderWithBackdrop from '$lib/components/ui-elements/HeaderWithBackdrop.svelte';
  import { authTokenParsed } from '$stores/authStore';
  import Alert from '../../ui-elements/Alert.svelte';
  import type { Institution } from '$lib/graphql/types';
  import { goto } from '$app/navigation';

  export let institutions: Institution[];

  let result: string | null = null;
  let error: string | null = null;

  let institution: Institution | undefined;
  let teamLongName = institutions[0].name;
  $: if (institutions?.length === 1) institution = institutions[0];

  async function handleSubmit() {
    if (!(institution?.name && institution?.id)) throw new Error('malformed institution');
    if (!$authTokenParsed) throw new Error('user information not available');

    // 1. Create the team
    let team = await new ParticipantCreateTeamStore().mutate(
      {
        name: teamLongName,
        long_name: teamLongName,
        institution_id: institution.id
      },
      {
        metadata: {
          role: 'participant'
        }
      }
    );

    if (team.errors) {
      console.error('Failed to create team', ...team.errors);
      error = team.errors.map((e) => e.message).join('\n');
      throw new Error(error);
    }

    const teamId = team.data?.insert_teams_one?.id;
    if (!teamId) {
      error = 'Failed to retrieve ID of new team.';
      throw new Error(error);
    }

    // 2. Add the current user to the team
    const membership = await new AddTeamMemberStore().mutate(
      { user_id: $authTokenParsed.id, team_id: teamId },
      { metadata: { role: 'participant' } }
    );

    if (membership.errors) {
      console.error('Failed to add user to team', ...membership.errors);
      error = membership.errors.map((e) => e.message).join('\n');
      return;
    }

    goto(`/user-dashboard/teams/${teamId}`);
    result = 'Great success!';
  }
</script>

<div class="my-5">
  <section class="w-full">
    <HeaderWithBackdrop size="sm" secondary wrap>Create A Team</HeaderWithBackdrop>
  </section>

  <Alert color="blue">
    <div slot="title">Important note about Team Creation</div>
    Faculty Liaisons should&nbsp;<b>not</b> create teams for their students or clubs. Each team should be created by the
    Team Captain for that team. New team captains can be promoted after the team is created, up until registration for an
    event closes.
  </Alert>

  <form
    class="flex flex-col gap-5 text-lg lg:text-xl font-semibold mt-10 w-full"
    on:submit|preventDefault={handleSubmit}>
    <section>
      <label for="team-name">Team Name</label>
      <input class="border rounded block w-full text-md font-normal p-1" type="text" bind:value={teamLongName} />
    </section>
    {#if institutions?.length > 1}
      <section>
        <label for="institution">Institution</label>
        <Alert class="mt-1 mb-2 font-normal" color="blue">
          Multiple institutions detected, please select your institution from the list. If your institution is not
          displayed, please do <b>not</b> register using a school you are not actively attending. Reach out to
          <a href="mailto:support@c2games.org">support@c2games.org</a> if you believe there has been an error
        </Alert>
        <select
          class="border rounded block w-full"
          bind:value={institution}
          on:change={() => (teamLongName = institution?.name ?? '')}>
          {#each institutions as inst}
            <option class="p-1" value={inst}>{inst.name}</option>
          {/each}
        </select>
      </section>
    {/if}
    <div class="w-full">
      <input
        data-umami-event="Submit New Team"
        class="cursor-pointer bg-cyber-blue-900 text-white py-1 px-10 w-full lg:w-fit lg:float-right"
        type="submit"
        value="Create Team" />
    </div>
  </form>
  {#if result}
    <Alert color="green" class="pt-2">
      <div slot="title">Team Created!</div>
      {result}
    </Alert>
  {/if}
  {#if error}
    <Alert color="red" class="pt-2">
      <div slot="title">Team Creation Failed</div>
      <p class="whitespace-pre-wrap">{error}</p>
      Please contact
      <a href="mailto:support@c2games.org">support@c2games.org</a>
      if this issue persists.
    </Alert>
  {/if}
</div>
